/* ========================================================================== * 
 * This file is part of CARDAMOM (R) which is jointly developed by THALES
 * and SELEX-SI. All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Library General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public
 * License for more details.
 * 
 * You should have received a copy of the GNU Library General
 * Public License along with CARDAMOM; see the file COPYING. If not, write to
 * the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * ========================================================================= */
 
 

#ifndef ___MARSHALLING_SERVER_EXECUTOR_IMPL_HPP__
#define ___MARSHALLING_SERVER_EXECUTOR_IMPL_HPP__

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>

#include "UserTestCcmMarshalling.skel.hpp"


namespace Marshalling
{
    
//
// IDL:thalesgroup.com/Marshalling/CCM_Server:1.0
//
class ServerExecutor_impl : virtual public User_Server, 
                            virtual public Cdmw::OrbSupport::RefCountLocalObject
{
  public:

    ServerExecutor_impl();
    
    ~ServerExecutor_impl();
    
    //
    // IDL:thalesgroup.com/Marshalling/CCM_Server/get_server_facet:1.0
    //
    virtual CCM_TestPing_ptr get_server_facet()
        throw(CORBA::SystemException);
       
    void set_session_context(Components::SessionContext_ptr ctx)
		         throw(CORBA::SystemException);
    void ccm_activate()
		         throw(CORBA::SystemException);
    void ccm_passivate()
		         throw(CORBA::SystemException);
    void ccm_remove()
		         throw(CORBA::SystemException);

  private:
  
    CCM_TestPing_var m_testCall;
    CCM_Server_Context_var m_session_context;
    
    
    ServerExecutor_impl(const ServerExecutor_impl&);
    
    void operator=(const ServerExecutor_impl&);
        
};


}; // End of namespace Marshalling

#endif // ___MARSHALLING_SERVER_EXECUTOR_IMPL_HPP__
